require 'open-uri'
require 'socket'
require 'yaml'
require 'rest-client'
require 'dim'

require 'ext/core'
require 'runpuppet/version'
require 'runpuppet/config'
require 'runpuppet/client'
require 'runpuppet/agent'
require 'runpuppet/logger'

STDOUT.sync = true


module Runpuppet
  def self.setup_context(options={})
    ctx = Dim::Container.new

    ctx.register(:run_options) do
      options
    end

    ctx.register(:config) do
      Runpuppet::Config.find_system_config
    end

    ctx.register(:client) do |context|
      Runpuppet::Client.new(context)
    end

    ctx.register(:agent) do |context|
      Runpuppet::Agent.new(context)
    end

    ctx.register(:logger) do
      Runpuppet::Logger
    end

    return ctx
  end
end
